﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

namespace PureChat.Plugins.OnTime
{
	public partial class AddDefect : OnTimePluginControl
	{
		protected override void OnInit(EventArgs e)
		{
			base.OnInit(e);
			btnSave.Click += btnSave_Click;
			this.Page.ClientScript.RegisterStartupScript(this.GetType(), "messagePopupId", string.Format("messagePopupId = '{0}';", messagePopup.ClientID), true);
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			if (!IsPostBack)
			{
				txtDefectName.Text = GetDefaultValue(Settings.DefectDefaultValues.ContainsKey("Name") ? Settings.DefectDefaultValues["Name"] : string.Empty);
				txtDescription.Text = string.Join(Environment.NewLine, ChatObject.ChatTranscript.ToArray());
				GetUserNames(ddlUsers, Settings.DefectDefaultValues.ContainsKey("AssignedToId") ? Settings.DefectDefaultValues["AssignedToId"] : OperatorName);
				GetProjects(ddlProjects, Settings.DefectDefaultValues.ContainsKey("ProjectId") ? Settings.DefectDefaultValues["ProjectId"] : string.Empty);
				GetStatusTypes(ddlStatus, Settings.DefectDefaultValues.ContainsKey("StatusTypeId") ? Settings.DefectDefaultValues["StatusTypeId"] : string.Empty);
				
			}
		}

		protected void btnSave_Click(object sender, EventArgs e)
		{
			OnTimeSDK.Defect.Defect defect = new PureChat.Plugins.OnTimeSDK.Defect.Defect();
			defect.AssignedToId = int.Parse(ddlUsers.SelectedValue);
			defect.Name = txtDefectName.Text.Trim();
			string description = txtDescription.Text;
			if (Settings.HtmlDetailFields)
				description = description.Replace(Environment.NewLine, "<br />");
			defect.Description = description;
			defect.ProjectId = ddlProjects.GetSelectedItemValue();
			if (!string.IsNullOrEmpty(ddlStatus.SelectedValue))
				defect.StatusTypeId = int.Parse(ddlStatus.SelectedValue);
			int defectId = 0;
			using (OnTimeSDK.Defect.DefectHandler handler = new PureChat.Plugins.OnTimeSDK.Defect.DefectHandler(Settings.DefectServiceUrl))
			{
				defectId = handler.AddDefect(Settings.SecurityGuid, defect);
			}
			Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId", string.Format("afterMessageFunc = closeWindow; url = '{0}'; setTimeout('showSuccessMessage(\"Defect added successfully! Defect Id - {{0}}\");', 250);", GetItemIdUrl(defectId.ToString(), "defect")), true);
		}
	}
}