﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

namespace PureChat.Plugins.OnTime
{
	public partial class AddFeature : OnTimePluginControl
	{
		protected override void OnInit(EventArgs e)
		{
			base.OnInit(e);
			btnSave.Click += btnSave_Click;
			this.Page.ClientScript.RegisterStartupScript(this.GetType(), "messagePopupId", string.Format("messagePopupId = '{0}';", messagePopup.ClientID), true);
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			if (!IsPostBack)
			{
				txtFeatureName.Text = GetDefaultValue(Settings.FeatureDefaultValues.ContainsKey("Name") ? Settings.FeatureDefaultValues["Name"] : string.Empty);
				txtDescription.Text = string.Join(Environment.NewLine, ChatObject.ChatTranscript.ToArray());
				GetUserNames(ddlUsers, GetDefaultValue(Settings.FeatureDefaultValues.ContainsKey("AssignedToId") ? Settings.FeatureDefaultValues["AssignedToId"] : OperatorName));
				GetProjects(ddlProjects, GetDefaultValue(Settings.FeatureDefaultValues.ContainsKey("ProjectId") ? Settings.FeatureDefaultValues["ProjectId"] : string.Empty));
				GetStatusTypes(ddlStatus, GetDefaultValue(Settings.FeatureDefaultValues.ContainsKey("StatusTypeId") ? Settings.FeatureDefaultValues["StatusTypeId"] : string.Empty));
			}
		}

		protected void btnSave_Click(object sender, EventArgs e)
		{
			OnTimeSDK.Feature.Feature feature = new PureChat.Plugins.OnTimeSDK.Feature.Feature();
			feature.AssignedToId = int.Parse(ddlUsers.SelectedValue);
			feature.Name = txtFeatureName.Text.Trim();
			string description = txtDescription.Text;
			if (Settings.HtmlDetailFields)
				description = description.Replace(Environment.NewLine, "<br />");
			feature.Description = description;
			feature.ProjectId = ddlProjects.GetSelectedItemValue();
			if (!string.IsNullOrEmpty(ddlStatus.SelectedValue))
				feature.StatusTypeId = int.Parse(ddlStatus.SelectedValue);
			int featureid = 0;
			using (OnTimeSDK.Feature.FeatureHandler handler = new OnTimeSDK.Feature.FeatureHandler(Settings.FeatureServiceUrl))
			{
				featureid = handler.AddFeature(Settings.SecurityGuid, feature);
			}
			Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId", string.Format("afterMessageFunc = closeWindow; url = '{0}'; setTimeout('showSuccessMessage(\"Feature added successfully! Feature Id - {{0}}\");', 250);", GetItemIdUrl(featureid.ToString(), "feature")), true);
		}
	}
}